Index: trunk/SophyaPI/PI/Quartz/PIMenuQuartz.cpp
===================================================================
--- trunk/SophyaPI/PI/Quartz/PIMenuQuartz.cpp	(revision 3326)
+++ trunk/SophyaPI/PI/Quartz/PIMenuQuartz.cpp	(revision 3747)
@@ -10,5 +10,5 @@
 #include "PIMenuQuartz.h"
 
-
+/* ----------------------------- Methode ------------------------------- */
 PIMenuQuartz::PIMenuQuartz(PIWdg* par, const char* nom, PIMenuType pdpu)
 :PIMenuGen(par, nom, pdpu)
@@ -17,17 +17,21 @@
     Str255 menuTitle;
 
+    mNItem = 0;  mNItemMax = 0;     
+    mMenuID = mMenuIdentificateur++;
+
+//    Beware with using this attribute, no place for check mark!
+//    CreateNewMenu (mMenuID, kMenuAttrExcludesMarkColumn, &mMenu);
+
 //  Popupmenu are associated with ButtonControl
     if (pdpu == k_PopupMenu)
-        {        
-        }
-    
-    mNItem = 0;  mNItemMax = 0;     
-    mMenuID = mMenuIdentificateur++;
-
-//    Beware with using this attribute, no place for check mark!
-//    CreateNewMenu (mMenuID, kMenuAttrExcludesMarkColumn, &mMenu);
-
-    CreateNewMenu (mMenuID,kMenuAttrAutoDisable, &mMenu);
-    
+	{
+		CreateNewMenu (mMenuID, kMenuAttrHidden, &mMenu);
+	}
+    else
+	{
+		CreateNewMenu (mMenuID, kMenuAttrAutoDisable, &mMenu);
+    }
+	
+	parent = par;
     CopyCStringToPascal (nom, menuTitle);
     SetMenuTitle (mMenu, menuTitle);
@@ -35,4 +39,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 PIMenuQuartz::~PIMenuQuartz()
 {
@@ -40,4 +45,5 @@
 }
 				   
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::AppendItem(const char* nom, PIMessage msg, char* sc)
 {
@@ -76,4 +82,5 @@
 }
 				   
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::AppendCheckItem(const char* nom, PIMessage msg, char* sc)
 {
@@ -85,4 +92,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::AppendPDMenu(PIMenuGen *pdm, char* sc)
 {
@@ -91,5 +99,5 @@
 }
 
-
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::AppendCascadeMenu(PIMenuQuartz* cascadeMenu, PIMessage msg)
 {
@@ -103,4 +111,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::AppendSeparator()
 {
@@ -112,4 +121,5 @@
 
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::DeleteItem(const char *nom)
 {
@@ -123,4 +133,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::DeleteItemMsg(PIMessage msg)
 {
@@ -128,4 +139,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::DeleteItemNum(int n)
 {
@@ -135,4 +147,5 @@
 
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::SetSensitivity(const char *nom, bool sens)
 {
@@ -143,4 +156,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::SetSensitivityMsg(PIMessage msg, bool sens) 
 {
@@ -151,4 +165,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::SetSensitivityNum(int n, bool sens)
 {
@@ -160,4 +175,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 bool PIMenuQuartz::IsSensitive(const char *nom)
 {
@@ -167,4 +183,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 bool PIMenuQuartz::IsSensitiveMsg(PIMessage msg)
 {
@@ -174,4 +191,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 bool PIMenuQuartz::IsSensitiveNum(int n)
 {
@@ -179,4 +197,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::SetState(const char *nom, bool st)
 {
@@ -187,4 +206,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::SetStateMsg(PIMessage msg, bool st)
 {
@@ -195,4 +215,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::SetStateNum(int n, bool st)
 {
@@ -200,4 +221,5 @@
 }
  
+/* ----------------------------- Methode ------------------------------- */
 bool PIMenuQuartz::GetState(const char *nom)
 {
@@ -208,4 +230,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 bool PIMenuQuartz::GetStateMsg(PIMessage msg)
 {
@@ -216,4 +239,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 bool PIMenuQuartz::GetStateNum(int n)
 {
@@ -221,4 +245,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::Show()
 {
@@ -227,4 +252,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 void PIMenuQuartz::Show(PIWdg *w, int px, int py)
 {
@@ -233,4 +259,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 PIMessage PIMenuQuartz::GetMsgItem(int itemID)
 {
@@ -246,4 +273,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 int PIMenuQuartz::GetNumItem(const char* nom)
 {
@@ -269,4 +297,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 int PIMenuQuartz::GetNumItemMsg(PIMessage msg)
 {
@@ -280,4 +309,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 char*  PIMenuQuartz::ItemName(int n)
 {
@@ -287,4 +317,5 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 MenuRef PIMenuQuartz::GetMenuRef()
 {
@@ -292,6 +323,15 @@
 }
 
+/* ----------------------------- Methode ------------------------------- */
 MenuID PIMenuQuartz::GetMenuID()
 {
     return (mMenuID);
 }
+
+/* ----------------------------- Methode ------------------------------- */
+PIWdg* PIMenuQuartz::GetParent()
+{
+    return (parent);
+}
+
+